<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) PHP-Fusion Inc
| https://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: s_bbcode_include.php
| Author: karrak
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
defined('IN_FUSION') || exit;

add_to_head("<style>
.stoverline {
    text-decoration: overline;
}
.stthrough {
    text-decoration: line-through;
}
.stunderline {
    text-decoration: underline;
}
.stall {
    text-decoration: underline overline;
}
</style>
");


if (preg_match_all('#\[strike(=(.*?))?\](.*?)\[/strike\]#si', $text)) {

    $text = preg_replace_callback(
        "#\[strike(=(?P<level>.*?))?\](?P<strike>.*?)\[/strike\]#si",
        function ($m) {
            $level = !empty($m['level']) ? $m['level'] : 'through';

            $div_html = "";
            switch ($level) {
                case $level == 'overline':
                    $div_html = "<div class='stoverline'>".$m['strike']."</div>";
                    break;
                case $level == 'through':
                    $div_html = "<div class='stthrough'>".$m['strike']."</div>";
                    break;
                case $level == 'underline':
                    $div_html = "<div class='stunderline'>".$m['strike']."</div>";
                    break;
                case $level == 'all':
                    $div_html = "<div class='stall'>".$m['strike']."</div>";
                    break;
                default:
                    $div_html = "<div class='stthrough'>".$m['strike']."</div>";

            }

            $html = "<div class='code_bbcode'>".$div_html."</div>";

            return $html;
        },
        $text
    );
}